SystemOrganization addCategory: #'GT-SpotterExtensions-Core'!

!TestCase class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:02'!
spotterForSuiteFor: aStep
	<demoyOnly: 'NautilusUI - this is an ugly implementaiton - just to demo it'>
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Suite';
		allCandidates: [ Array with: self suite ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfSuite: item notifying: true ];
		matchSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!TestCase class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:03'!
spotterForSuitesFor: aStep
	<demoOnly: 'NautilusUI - this is an ugly implementaiton - just to demo it '>
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Testcases';
		allCandidates: [ 
			self testSelectors collect: [ :each | 
				(self buildSuiteFromMethods: { each }) name: each; yourself ] ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfSuite: item notifying: true ];
		matchSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/18/2015 09:52'!
allAncestors
	^ OrderedCollection streamContents: [ :stream |
		self allAncestorsDo: [ :versionInfo | 
			stream nextPut: versionInfo ] ]! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/18/2015 09:54'!
diffAgainstWorkingCopy
	<demoOnly: 'this is really ugly, actually monticello should provide all the necessary utilities in order to do such things more conveniently'>
	| repository workingCopy package workingCopyVersion version | 
	workingCopy := (MCWorkingCopy allManagers 
		detect: [ :each | each ancestry hasAncestor: self ]
		ifNone: [ nil ]).
	workingCopy 
		ifNotNil: [
			package := workingCopy package.
			repository := workingCopy repositoryGroup repositories anyOne.
			workingCopyVersion := repository versionWithInfo: workingCopy versionInfo ifAbsent: [ ^ self halt ].
			version := repository versionWithInfo: self ifAbsent: [ ^ self halt ].
			((MCFileRepositoryInspector repository: repository workingCopy: workingCopy) 
				version: version;
				yourself) changes ] 
		ifNil: [ self halt ]! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 16:54'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 19:22'!
spotterAncestorsFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		actLogic: [ :aMCVersionInfo | aMCVersionInfo diffAgainstWorkingCopy ];
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/18/2015 13:11'!
compileExpression: query on: stream processor: processor
	| object result candidates |
	candidates := OrderedCollection new.
	(query substrings: ' ') size > 1 ifFalse: [ ^ candidates ].
	object := [ Compiler evaluate: query ] on: Error do: [ ^ candidates ].
	object isNumber ifFalse: [
		stream addObject: object inProcessor: processor.
		candidates add: object ].
	result := [ object gtSpotterExpression: { self. processor } ] on: Error do: [ ^ candidates ].
	object = result ifFalse: [ 
		stream addObject: result inProcessor: processor.
		candidates add: result ].
	^ candidates! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/18/2015 13:09'!
evaluateExpression: query on: stream processor: processor
	| result candidates |
	candidates := OrderedCollection new.
	(Number selectors anySatisfy: [ :selector | 
		query includesSubstring: selector caseSensitive: true ]) ifFalse: [ ^ candidates ].
	result := [ Compiler evaluate: query ] on: Error do: [ ^ candidates ].
	stream addObject: result inProcessor: processor. 
	candidates add: result. 
	(result isFraction and: [ result isInteger not ]) ifTrue: [ 
		stream addObject: result asFloat inProcessor: processor.
		candidates add: result ].
	^ candidates! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/19/2015 21:27'!
filterByQuery: originalQuery forReferencesComputedAs: fileReferencesBlock inProcessor: processor onStream: stream
	| prefixMatchers split rootDirectory query fullQuery rest |
	fullQuery := originalQuery trimBoth asLowercase.
	split := fullQuery piecesCutWhere: [ :a :b | a = FileSystem disk delimiter ].
	split size < 1
		ifTrue: [ 
			query := fullQuery.
			rootDirectory := FileSystem workingDirectory ]
		ifFalse: [ 
			(split last last = FileSystem disk delimiter)
				ifTrue: [ 
					query := ''.
					rootDirectory := fullQuery asFileReference ]
				ifFalse: [ 
					query := split last.
					rootDirectory := ('' join: split allButLast) asFileReference ] ].
	rootDirectory exists ifFalse: [ ^ OrderedCollection new ].
	query isEmpty ifTrue: [ 
		| all |
		all := fileReferencesBlock value: rootDirectory.
		(all first: (all size min: 5)) do: [:reference | stream addObject: reference inProcessor: processor].
		^ all  ].
	prefixMatchers := OrderedCollection new.
	rest := OrderedCollection new.
	(fileReferencesBlock value: rootDirectory) do: [ :reference | 
			| index |
			index := reference basename findString: query startingAt: 1 caseSensitive: false.
			index >= 1 ifTrue: [ 
				index = 1 
					ifTrue: [ 
						prefixMatchers add: reference.
						prefixMatchers size > 5
							ifFalse: [ stream addObject: reference inProcessor: processor ] ]
					ifFalse: [ rest add: reference ] ] ].
	prefixMatchers size < 5
		ifTrue: [ (rest first: (5 - prefixMatchers size min: rest size)) do: [ :each | stream addObject: each inProcessor: processor ] ].
	^ prefixMatchers , rest! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/12/2015 22:16'!
spotterConcreteMethodFor: aStep
    <spotterOrder: 30>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Method';
		filter: [ :originalQuery :stream |
			| method result |
			result := OrderedCollection new.
			[
				Transcript show: originalQuery trimBoth; cr.
				method := Compiler evaluate: originalQuery trimBoth.
				method class = CompiledMethod ifTrue: [
					stream addObject: method inProcessor: processor.
					result add: method ] 
			] on: Error do: [  ].
			result ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:16'!
spotterDirtyMonticelloPackagesFor: aStep
	<spotterOrder: 85>
	aStep listProcessor
			allCandidates: [ MCWorkingCopy allManagers select: #modified ];
			title: 'Dirty Monticello packages';
			itemIcon: [ Smalltalk ui icons iconNamed: #dirtyPackageIcon ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 14:20'!
spotterForClassesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			allCandidates: [ Smalltalk allClassesAndTraits ];
			title: 'Classes';
			matchSubstring;
			itemIcon: #systemIcon;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 13:10'!
spotterForCompilerFor: aStep
	<spotterOrder: 1>
	| processor |
	(processor := aStep listProcessor)
		title: 'Expressions';
		filter: [ :query :stream | 
			self compileExpression: query on: stream processor: processor ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 02:17'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 50>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Directories';
		itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
		wantsToDisplayOnEmptyQuery: false;
		filter: [ :originalQuery :stream | 
					self
						filterByQuery: originalQuery
						forReferencesComputedAs: [ :root | root directories ]
						inProcessor: processor
						onStream: stream ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 12:44'!
spotterForExpressionsFor: aStep
	<spotterOrder: 1>
	| processor |
	(processor := aStep listProcessor)
		title: 'Expressions';
		filter: [ :query :stream | 
			self evaluateExpression: query on: stream processor: processor ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 02:17'!
spotterForFilesFor: aStep
	<spotterOrder: 40>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Files';
		itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
		wantsToDisplayOnEmptyQuery: false;
		filter: [ :originalQuery :stream | 
					self
						filterByQuery: originalQuery
						forReferencesComputedAs: [ :root | root files ]
						inProcessor: processor
						onStream: stream ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterForGlobalVarsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			allCandidates: [ Smalltalk globals associations select:[:assoc | 
			assoc value isBehavior not and:[ 
				assoc value isTrait not]] ];
			title: 'Global variables';
			itemName:[:global | global key ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:28'!
spotterForMetacelloConfigurationsFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
			title: 'Metacello Configurations';
			allCandidatesProxied: [ 
				Smalltalk allClassesAndTraits select: [ :each | 
					(each respondsTo: #isMetacelloConfig) 
						and: [ each isMetacelloConfig
							and: [ each name beginsWith: 'ConfigurationOf' ] ] ] ];
			itemIcon: #systemIcon;
			matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterForPackagesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ RPackageOrganizer default packages ];
			title: 'Packages';
			itemName: [ :package | package name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterForPlaygroundPagesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
			allCandidates: [ GTPlayBook instance pages ];
			title: 'Playground';
			itemName: [ :page | page content asString contractTo: 100 ];
			matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/14/2015 19:26'!
spotterForPragmasFor: aStep
	<spotterOrder: 40>
	aStep listProcessor 
			allCandidates: [:x | PragmaType all ];
			title: 'Pragmas';
			itemName: [ :pragma | pragma keyword ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:28'!
spotterForRepositoriesFor: aStep
	<spotterOrder: 22>
	aStep listProcessor
		title: 'Monticello Repositories';
		allCandidates: [ MCRepositoryGroup default repositories ];
		itemIcon: #systemIcon;
		wantsToDisplayOnEmptyQuery: false;
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:30'!
spotterForSlotsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Slots';
		allCandidates: [ Slot allSubclasses ];
		itemIcon: #systemIcon;
		wantsToDisplayOnEmptyQuery: false;
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:54'!
spotterForTestClassesFor: aStep
	<demoOnly: 'NautilusUI - this is a very ugly implementaiton - just for demo'>
	<spotterOrder: 20>
	aStep listProcessor
		title: 'Suites';
		allCandidates: [ TestCase allSubclasses ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfClass: item notifying: true ];
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:31'!
spotterForTraitsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Traits';
		allCandidates: [ Smalltalk allTraits ];
		itemIcon: #systemIcon;
		wantsToDisplayOnEmptyQuery: false;
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 07:07'!
spotterHistoryFor: aStep
	<spotterOrder: 80>
	aStep listProcessor
			allCandidates: [:x | self class history select: [ :each | each isNotNil ] ];
			title: 'History';
			matchSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'DamienCassou 2/9/2015 15:40'!
spotterImplementorsFor: aStep
	<spotterOrder: 30>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Implementors';
		filter: [ :originalQuery :stream | 
					GTImplementorsSpotter new
						query: originalQuery;
						stream: stream;
						processor: processor;
						behaviors: SystemNavigation default allBehaviors;
						find ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:11'!
spotterMonticelloPackagesFor: aStep
	<spotterOrder: 22>
	aStep listProcessor
		title: 'Monticello Packages';
		allCandidates: [ MCWorkingCopy allManagers collect: [ :each | each package ] ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:35'!
spotterMonticelloWorkingCopiesFor: aStep
	<spotterOrder: 23>
	aStep listProcessor
		title: 'Monticello Working Copies';
		allCandidates: [ MCWorkingCopy allManagers ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 06:23'!
spotterStfxFor: aStep
	<spotterOrder: 30>
	| processor |
	processor := aStep listProcessor.
	processor 
		title: 'ws.stfx.eu';
		filter: [ :originalQuery :stream |
			| aCollection query |
			aCollection := OrderedCollection  new.
			query := originalQuery trimBoth.
			(query beginsWith: 'http://ws.stfx.eu') ifTrue: [ 
				[| string page |
				string := GTUrlProvider new get: query.
				page := GTPlayPage new content: string.
				stream addObject: page inProcessor: processor.
				aCollection add: page] on: Error do: [ "nothing" ] ].
			aCollection ].
	^ processor! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/17/2014 12:56'!
spotterWorldMenuFor: aStep
	<spotterOrder: 9>
	^ (World worldMenu spotterItemsFor: aStep)
		title: 'Menu'! !

!BlockClosure methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 12:19'!
gtSpotterExpression: arguments
	^ self valueWithPossibleArgs: arguments! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/11/2014 21:21'!
spotterActDefault
	^ PackageTreeNautilus openOnPackage: self! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self definedClasses sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 22:29'!
spotterExtensionMethodsFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			allCandidates: [ self extensionMethods ];
			title: 'Extension Methods';
			matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:11'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ Array with: self mcPackage ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:35'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 42>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ Array with: self mcPackage workingCopy ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:01'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite list
		title: 'Preview';
		display: [ :x | x ];
		format: [ :class | GTSpotterItemBrick new text: class gtDisplayString; icon: class systemIcon; disable; yourself ];
		entity: self classes asArray.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/7/2014 00:29'!
spotterTagsFor: aStep
	<spotterOrder: 20>
	self classTags size <= 1 ifTrue: [ ^ self ].
	aStep listProcessor
			allCandidates: [ self classTags sorted: [ :a :b | a name < b name ] ];
			title: 'Tags';
			matchSubstring! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:17'!
gtDisplayOn: aStream
	aStream nextPutAll: self name! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:38'!
spotterForPackageFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ Array with: self correspondingRPackage ];
		itemName: [ :package | package name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		matchSubstring! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:35'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ Array with: self workingCopy ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		matchSubstring! !

!Behavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/16/2015 12:26'!
spotterClassInstanceVariablesFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Class instance variables';
			allCandidates: [ self class layout allSlots ];
			itemName: [:each | each name asString];
			matchSubstring! !

!Behavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/16/2015 12:26'!
spotterInstanceVariablesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Instance variables';
			allCandidates: [ self layout allSlots ];
			itemName: [:each | each name asString];
			matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 19:22'!
allAncestors
	^ self versionInfo 
		ifNotNilDo: [ :versionInfo | versionInfo allAncestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:01'!
gtDisplayOn: stream
	ancestry ancestors isEmpty 
		ifTrue: [ 
			super gtDisplayOn: stream. stream nextPutAll: ' (unsaved)' ]
		ifFalse: [ 
			ancestry ancestors first gtDisplayOn: stream.
			self needsSaving ifTrue: [ stream nextPutAll: ' (modified)' ] ]
		! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 18:09'!
nextAncestors
	^ self versionInfo 
		ifNotNilDo: [ :versionInfo | versionInfo ancestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 00:02'!
spotterAllRepositoriesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
		title: 'All other repositories';
		allCandidates: [ MCRepositoryGroup default repositories \ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:56'!
spotterAncestorsFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		actLogic: [ :aMCVersionInfo | aMCVersionInfo diffAgainstWorkingCopy ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/3/2014 07:34'!
spotterCommit: workingCopy in: aRepository
	| newVersion |

	newVersion := workingCopy newVersionIn: aRepository.
	newVersion ifNil: [ ^ self ].
	Cursor wait showWhile: [
		[ 	aRepository storeVersion: newVersion.
			aRepository storeDependencies: newVersion ] 
		ensure: [ (MCVersionInspector new version: newVersion) show ]]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 10:11'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ Array with: self package ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:38'!
spotterPackageFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ Array with: self package correspondingRPackage ];
		itemName: [ :item | item name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/4/2014 22:10'!
spotterPackageRepositoriesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Package repositories';
		allCandidates: [ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 18:08'!
versionInfo
	^ self ancestors 
		ifNotEmptyDo: [ :list | list first ] 
		ifEmpty: [ nil ]! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 10:39'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self class methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!MCHttpRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:50'!
gtDisplayOn: aStream
	aStream nextPutAll: self location! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:33'!
spotterActDefault
	^ self browse! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:36'!
spotterClassMethodsFor: aStep
	^ self explicitRequirement! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:11'!
spotterMethodsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Instance methods';
			allCandidates: [ self methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:04'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [self name];
		display: #definitionForNautilus;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:13'!
spotterReferenceFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self binding) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			matchSubstring! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/21/2014 11:13'!
spotterActDefault
	self doButtonAction! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 12:21'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	self hasSubMenu ifTrue: [ 
		self subMenu spotterItemsFor: aStep ]! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 03:21'!
spotterPreviewMenuIn: aComposite
	<spotterPreview: 10>
	
	aComposite list
		title: [ self contents ];
		display: #yourself;
		format: [ :item | 
			GTSpotterItemBrick new 
				text: item contents; 
				icon: item icon; 
				disable;
				yourself ];
		styled: [ :brick | brick ];
		entity: (self hasSubMenu ifFalse: [ {self} ] ifTrue: [ self subMenu allItems ]).
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!MCRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:53'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

!MCRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:51'!
spotterMonticelloPackagesFor: aStep
	<bug: 'this will not work as spotter terminates the process prematurely - remote filelisting is slow'>
	<demoOnly>
	<spotterOrder: 1>
	aStep listProcessor
		title: 'packages';
		allCandidates: [ self allFileNamesOrCache ];
		itemName: [ :item | item asString ];
		matchSubstring! !

!Slot methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/1/2014 14:32'!
spotterAccessesFor: aStep
	<spotterOrder: 10>
	(aStep spotter hasPreviousStep and: [
		(aStep spotter previousStep origin isKindOf: Class) or: [
			aStep origin isKindOf: Class]]) ifTrue: [
		aStep listProcessor
				title: 'Accesses';
				allCandidates: [ 
					SystemNavigation default 
						allAccessesTo: self name 
						from: aStep spotter previousStep origin ];
				itemName: [:each | each asString];
				matchSubstring ]! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/9/2015 20:49'!
spotterCompositionFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Composing traits';
			allCandidates: [ self traitComposition allTraits ];
			itemIcon: #systemIcon;
			matchSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:41'!
spotterSubclassesFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'All subclasses';
			allCandidates: [ self allSubclasses ];
			itemIcon: #systemIcon;
			matchSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:42'!
spotterSuperclassesFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			title: 'All superclasses';
			allCandidates: [ self allSuperclasses ];
			itemIcon: #systemIcon;
			matchSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/9/2015 20:50'!
spotterTraitUsersFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Users';
			allCandidates: [ self traitUsers asArray ];
			itemIcon: #systemIcon;
			matchSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:48'!
spotterUsedTraitsFor: aStep
	<spotterOrder: 60>
	aStep listProcessor
			title: 'Uses Traits';
			allCandidates: [ self traits asArray ];
			itemIcon: #systemIcon;
			matchSubstring! !

!RPackageTag methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 15:54'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self classes sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self browse! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForImplementorsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Implementors';
			allCandidates: [ self implementors collect: #compiledMethod ];
			itemName: [ :method | method printString ];
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForSendersFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Senders';
			allCandidates: [ self senders collect: #compiledMethod ];
			itemName: [ :method | method printString ];
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/20/2014 23:13'!
spotterItemsFor: aStep
	"do nothing for compiled method"! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:20'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [ self gtDisplayString ];
		display: [:compiledMethod | 
			' ', compiledMethod getSource];
		smalltalkClass: #methodClass;
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterActDefault
	self value inspect! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:36'!
spotterClassFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Class';
			allCandidates: [ { self value class }];
			itemIcon: #systemIcon;
			matchSubstring! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:36'!
spotterReferenceFor: aStep
	<spotterOrder: 130>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			matchSubstring! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:00'!
spotterActDefault
	^ GTPlayground new openOn: self! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:02'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: 'Preview';
		display: #content;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/2/2015 14:34'!
isZipFile
	^ self isFile and: [ #('zip' 'jar' 'ear' 'war') includes: self extension ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 02:20'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 10>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			matchSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 02:20'!
spotterForFilesFor: aStep
	<spotterOrder: 20>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			matchSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/2/2015 14:46'!
spotterForZipDirectoriesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			matchSubstring! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/2/2015 14:46'!
spotterForZipFilesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			matchSubstring
	! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 22:08'!
spotterPreviewContentsIn: aComposite
	<spotterPreview: 20>
	
	self isFile ifFalse: [ ^ self ].
	aComposite custom: 
		(RubScrolledTextMorph new
			setTextWith: (self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ]) )! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:00'!
spotterPreviewItemsIn: aComposite
	<spotterPreview: 10>
	
	self isDirectory ifFalse: [ ^ self ].
	aComposite list
		title: [ self gtDisplayString ];
		display: #yourself;
		format: [ :folder | 
			GTSpotterItemBrick new 
				text: folder basename; 
				icon: (folder isDirectory 
								ifTrue: [Smalltalk ui theme icons glamorousFolder]
								ifFalse: [Smalltalk ui theme icons glamorousBrowse] ); 
				disable; 
				yourself ];
		styled: [ :brick | brick ];
		entity: self directories, self files.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:57'!
spotterPreviewPngIn: aComposite
	<spotterPreview: 10>
	
	(self mimeTypes notNil and: [ 
		self mimeTypes first matches: ZnMimeType imagePng ]) 
		ifFalse: [ ^ self ].
	aComposite custom: 
		((self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ])
			asAlphaImageMorph asBrick margin: 20)! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 22:46'!
spotterPreviewStScriptIn: aComposite
	<spotterPreview: 10>
	
	(self extension = 'st' or: [self extension = 'ph']) 
		ifFalse: [ ^ self ].
	aComposite pharoMethod 
		display: #yourself;
		smalltalkClass: [ nil ];
		entity: (self readStreamDo: #contents)! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/22/2014 17:33'!
allItems
	| all |
	all := OrderedCollection new.
	self items do: [ :each |
		all add: each.
		each hasSubMenu 
			ifTrue: [ all addAll: each subMenu allItems ] ].
	^ all! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor 
		title: 'Items';
		candidatesLimit: Float infinity;
		allCandidates: [ self items ];
		itemName: #contents;
		itemIcon: [ :item | item icon ];
		actLogic: [ :item | item hasSubMenu 
					ifTrue: [ aStep diveIn ] 
					ifFalse: [ item spotterActDefault. aStep exit ] ];
		matchSubstring ! !

!TClassDescription methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:51'!
spotterPackageFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Package';
			allCandidates: [ {self package} ];
			itemIcon: #systemIcon;
			matchSubstring! !

!AbstractNautilusUI methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:55'!
runTestsOfSuite: aSuite notifying: aBoolean
	<demoOnly: 'this is very ugly code, a copy from the original implementation, adapted to aSuite'>
	|  blockToEvaluate result |

	blockToEvaluate := [
		[ 
		| classes |
		classes := (aSuite tests collect: [ :each | each class ]) asSet.
		classes do: [ :class | class resetHistory ].
		result := aSuite run.
		result updateResultsInHistory.
		classes do: [ :class | ClassesIconsCache removeKey: class ifAbsent: []. ].
		testSemaphore signal. ] on: Exception do:[:e | testSemaphore signal . e defaultAction]].

	aBoolean 
		ifTrue: [ blockToEvaluate forkAt: Processor userBackgroundPriority ]
		ifFalse: [ blockToEvaluate value ].

	testSemaphore
		initSignals;
		wait.
	
	aBoolean 
		ifTrue: [ 
			| color |
			color := Color gray.
			result hasPassed ifTrue: [ color :=  Color green ].
			result hasFailures ifTrue: [ color :=  Color yellow ].
			result hasErrors ifTrue: [ color :=  Color red ].
			
			self 
				notifyTitle: 'Test Finished' 
				contents: 'Class: ', aSuite name
				color: color ]! !

!MCDirectoryRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:51'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

Object subclass: #GTImplementorsSpotter
	instanceVariableNames: 'query stream processor behaviors limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!GTImplementorsSpotter methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 12:48'!
behaviors: aCollection 
	behaviors := aCollection! !

!GTImplementorsSpotter methodsFor: 'action' stamp: 'TudorGirba 2/12/2015 22:17'!
find
	| prefixMatchers rest |
	prefixMatchers := OrderedCollection new.
	rest := OrderedCollection new.
	query isEmpty ifFalse: [ 
			behaviors
				do: [ :class | 
					class
						selectorsDo: [ :selector | 
							| index |
							index := selector findString: query startingAt: 1 caseSensitive: false.
							index >= 1
								ifTrue: [ 
									| method |
									method := class >> selector.
									index = 1
										ifTrue: [ 
											prefixMatchers add: method.
											prefixMatchers size > limit
												ifFalse: [ stream addObject: method inProcessor: processor ] ]
										ifFalse: [ rest add: method ] ] ] ].
			prefixMatchers size < limit
				ifTrue: [ (rest first: (limit - prefixMatchers size min: rest size)) do: [ :each | 
						stream addObject: each inProcessor: processor ] ] ].
	^ prefixMatchers , rest ! !

!GTImplementorsSpotter methodsFor: 'action' stamp: 'DamienCassou 2/4/2015 12:48'!
find: aString 
	query := aString.
	self find! !

!GTImplementorsSpotter methodsFor: 'initialization' stamp: 'DamienCassou 2/4/2015 14:28'!
initialize
	super initialize.
	limit := 5! !

!GTImplementorsSpotter methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 12:58'!
limit: aNumber
	limit := aNumber! !

!GTImplementorsSpotter methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 12:47'!
processor: aProcessor
	processor := aProcessor! !

!GTImplementorsSpotter methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 14:34'!
query: aString 
	query := aString! !

!GTImplementorsSpotter methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 12:47'!
stream: aGTSpotterStream
	stream := aGTSpotterStream! !

!Object methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 12:50'!
gtSpotterExpression: arguments
	^ self! !

Object subclass: #PragmaType
	instanceVariableNames: 'keyword pragmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!PragmaType commentStamp: 'TudorGirba 11/16/2014 12:57' prior: 0!
This models the type of pragma instances.

It essentially knows the keyword that defines the Pragma, and can obtain all occurences of that Pragma.

!!!!Example

[[[
	PragmaType all
]]]!

!PragmaType class methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
all
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	^ (pragmas groupedBy: #keyword) associations collect: [ :association |
		PragmaType new
			keyword: association key; 
			pragmas: association value ] ! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:54'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Pragmas';
		display: [ self pragmas ];
		format: #gtDisplayString! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword
	^ keyword! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword: anObject
	keyword := anObject! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:58'!
pragmas
	^ pragmas ifNil: [
		pragmas := OrderedCollection new.
		Object withAllSubclassesDo: [ :each |
			Pragma withPragmasIn: each do: [ :p |
				p keyword = self keyword ifTrue: [ 
					pragmas add: p ] ] ].
		pragmas ]! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
pragmas: aCollection
	pragmas := aCollection! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:53'!
printOn: stream
	stream nextPutAll: self keyword! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterPragmasFor: aStep
	<spotterOrder: 40>
	^ aStep listProcessor
		title: 'Pragmas';
		allCandidates: [ self pragmas ];
		itemName: [ :pragma | pragma method printString , ' ' , pragma asString ];
		matchSubstring! !

!PragmaType methodsFor: 'as yet unclassified' stamp: 'TudorGirba 2/15/2015 23:03'!
spotterSendersFor: aStep
	<spotterOrder: 50>
	^ aStep listProcessor
		title: 'Senders';
		allCandidates: [ (SystemNavigation default allSendersOf: self keyword) 
									collect: #compiledMethod ];
		matchSubstring! !

!Trait methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:27'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self classTrait methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!MessageSend methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 12:21'!
gtSpotterExpression: someArguments
	^ self glamourValueWithArgs: someArguments! !

!Collection methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/15/2015 23:29'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	(self allSatisfy: [ :each | 
		each class = GTSpotterCandidateLink ])
		ifFalse: [ ^ self ].
	^ aStep listProcessor
		title: 'Items';
		candidatesLimit: 100;
		allCandidates: [ OrderedCollection newFrom: (self collect: [ :each | each copy ])];
		itemName: [ :each | each renderingProcessor itemNameFor: each value ];
		matchSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/15/2014 00:01'!
spotterActDefault
    ^ self method browse! !
